	list p=16f84
;**************************************************************
;*
;*	----------------------------------	
;*	PORTA: 	0 
;*		1 
;*		2 
;*		3 seriell Input
;*		4 
;*	PORTB:	0 LED	   
;*		1 LED
;*		2 LED
;*		3 LED 
;*		4 LED
;*		5 LED
;*		6 LED
;*		7 LED
;*
;**************************************************************
;
;sprut (zero) Bredendiek 05/2000 (mod. 01/2002; 09/2003)
;
; Empfangen via RS-232
; input : RA3  (keine RS232-Treiberschaltkreise verwenden, 
;               sondern 22 kOhm Reihenwiderstand)
; Takt  : 4 MHz
;
; Empfangener Code wird am Port B ausgegeben
;
;**************************************************************
; Includedatei fr den 16F84 einbinden

	#include <P16f84.INC>

; Configuration festlegen
; bis 4 MHz: Power on Timer, kein Watchdog, XT-Oscillator

	__CONFIG	_PWRTE_ON & _WDT_OFF & _XT_OSC

;**************************************************************
;Variablennamen vergeben


cycl_1	Equ	0x20		; zhler 
cycl_2	Equ	0x21		; zhler
rs232in	Equ	0x22
Byte	Equ	0x23
Temp	Equ	0x24
in	Equ	3		;RS-232  in ist RA3

;**************************************************************
; los gehts mit dem Programm
; Port B auf Ausgabe stellen

Init
	bsf     STATUS, RP0	; auf Bank 1 umschalten
	movlw	B'00000000'	; PortB alle output
	movwf	TRISB
	bcf     STATUS, RP0	; auf Bank 0 zurckschalten
	clrf	PORTA		; 
	clrf	PORTB		; alle LEDs ausschalten

;Zeichen empfangen und dann an PORTB ausgeben
Loop
	call	ser_RX		; Code von RS232 empfangen
	movfw	rs232in		;
	movwf	PORTB		; empfangenen Code am PORTB ausgeben (LEDs)
	goto	Loop

;**********************************************************
;empfangen eines Byte nach 'byte', 'rs232in' und w 

ser_RX	clrf	Byte		;! Nullsetzen
	movlw	8
	movwf	cycl_1		;  8 mal	
	btfss	PORTA, in	;  warten bis Startbit
	goto	ser_RX
	call	Pause		; Zeitverzgerung 1/2 Bit
	btfss	PORTA, in	
	goto	ser_RX
	
RX_2	call	Warte		; Zeitverzgerung 1 Bit
	btfsc	PORTA, in	;
	bcf	STATUS, C	; high -> 0
	btfss	PORTA, in	;
	bsf	STATUS, C	; low  -> 1
				;
	rrf	Byte, f		;
	decfsz	cycl_1, f	;
	goto	RX_2		; 8 mal
	
	call	Warte		; Zeitverzoegerung 1 bit
	btfsc	PORTA, in	; Stop-Bit 1
	goto	ser_RX		; wenn kein StopBit 1

	movf	Byte, w
	movwf	rs232in
	return

;**********************************************************
;ein bit zeitverzoegerung
; dieses timing mu genau stimmen (5%)
;
; empfang           4 MHz    10 MHz
; 2400 Bps =          69d    173d
; 4800 Bps =          34d     86d
; 9600 Bps =          16d     43d 

Warte	movlw	D'16'		; 9600 Bps / 4 MHz empfangen
	movwf	cycl_2 
Warte1				; 6 Zyklen-Schleife
	nop
	nop
	nop
	decfsz	cycl_2, 1	
	goto	Warte1
	return

;**********************************************************
;1/2 bit zeitverzoegerung
; dieses Timing ist nicht ganz so kritisch (25%)
;
;                4 MHz       10 MHz
; 2400 Bps =  416T =  63d    157d
; 4800 Bps =          31d     78d
; 9600 Bps =          15d     39d 
;
Pause	movlw	D'15'		; 9600 Bps / 4 MHz
	movwf	Temp
Pause2				; 3 Zyklen Schleife
	decfsz	Temp, f	
	goto	Pause2
	return

;**********************************************************

	end





